=== debian/changelog ===
paraview (5.4.1+dfsg4-4) unstable; urgency=medium

  * Team upload.
  * [64c0c0d] Trim trailing whitespace.
  * [bcf3d00] Use secure URI in Homepage field.
  * [c5cb7ab] Add Alastair as an uploader.
  * [5119941] Fix indents.

 -- Anton Gladky <gladk@debian.org>  Sat, 10 Aug 2019 10:24:34 +0200

paraview (5.4.1+dfsg4-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream FTBFS fixes, thanks to Juhani Numminen.
    (Closes: #906714)
  * Remove tcl8.5 as first dependency alternative. (Closes: #905980)

 -- Adrian Bunk <bunk@debian.org>  Mon, 17 Sep 2018 19:59:09 +0300

paraview (5.4.1+dfsg4-3) unstable; urgency=medium

  * Team upload
  * d/p/disable-local-FindMPI: fix FTBS with latest openmpi
  * d/ruled: Remove forced MPI include path, it is no longer valid

 -- Gert Wollny <gewo@debian.org>  Sun, 22 Apr 2018 12:35:56 +0200

paraview (5.4.1+dfsg4-2) unstable; urgency=medium

  * Team upload.
  * [bd12fc4] d/p/fix_opengl_arm: use Extra OpenGL functions
    Closes: #893735

 -- Gert Wollny <gewo@debian.org>  Fri, 23 Mar 2018 22:47:21 +0000

paraview (5.4.1+dfsg4-1) unstable; urgency=medium

  * Team upload.
  * [a7b9430] New upstream version 5.4.1+dfsg4
  * [117a771] Use backend OpenGL2
  * [c5d2240] d/p/fix_gl2ps Update OpenGL2 backend
  * [145a06f] d/rules: Switch to qt5
  * [a7aaa49] d/control: Switch to qt5
  * [fa81501] d/copyright: remove duplicate BSD-3-clause section
  * [033db76] d/source: Add some overrides for the package

 -- Gert Wollny <gewo@debian.org>  Thu, 15 Mar 2018 19:02:28 +0100

paraview (5.4.1+dfsg3-2) unstable; urgency=medium

  * Team upload.

  [ Gert Wollny ]
  * [d289ee3] d/copyright: update copyright based on the ftp-master comments for vtk7

  [ Anton Gladky ]
  * [e9be492] Remove deprecated Testsuite-field
  * [4952ac8] Set compat level to 11
  * [f2d150a] Set priority optional
  * [f122067] Set Standards-Versions: 4.1.3
  * [c19be5e] Update VCS-fields
  * [762408d] Apply cme fix dpkg
  * [c1cfeae] Remove myself from uploaders

 -- Anton Gladky <gladk@debian.org>  Wed, 07 Mar 2018 21:00:16 +0100
